<?php
include("../peruskoodi.php");
?>

<?php


	/* Mritelln kansio, jossa ovat kvijtiedot sisltvt tiedostot omissa kansioissaan. */
	$kavijatKansio = "../";


	/* Funktio, joka lukee kvijmrn parametrina annetusta tiedostosta.
	Jos tiedostoa ei ole olemassa, on tiedoston kvijmr 0. */

	function lueKavijamaara ($tiedosto)
	{
		if (file_exists($tiedosto))
			return file_get_contents($tiedosto);
		else
			return 0;
	}


	/* Funktio, joka laskee parametrina annetun kansion tiedostojen lukumrn, jotka ovat tiedostonimeltn 
	parametrina annettua muotoa. */

	function laskeTiedostot ($kansio, $tiedostoMuoto) {

		/* Alustetaan laskuri. */
		$laskuri = 0;

		/* Avataan kansio ja luetaan sielt kaikki tiedostot. Jos tiedosto on funktion parametrina annettua
		muotoa, kasvatetaan laskuria yhdell. */

		if ($handle = opendir($kansio)) 
		{	
		
			while (false !== ($file = readdir($handle))) 
			{ 		
				if ($file != "." && $file != ".." && ereg($tiedostoMuoto,$file))
					$laskuri++;					
			}
			
			closedir($handle); 

		}

		/* Palautetaan lopulta laskurin laskema tiedostojen mr. */
		return $laskuri;
	}


	/* Funktio, joka piirt kuvaajan kvijmrist parametrina annetusta aloituspivst parametrina annettuun 
	lopetuspivn asti. Kvijmrt haetaan parametrina annetusta kansiosta. Kuvaaja tallennetaan png-kuvana 
	parametrina annetuun kuvan osoitteeseen. Pivmrt pit olla UNIX-timestamp -muodossa ja kvijtietojen 
	kansion osoitteen lopussa pit olla kauttaviiva ("/"). Kuvan koko mritelln funktion parametreissa erikseen 
	x- ja y-suuntaan. */

	function piirraKuvaaja ($aloitusPaivamaara, $lopetusPaivamaara, 
	$kavijaTiedotKansio, $kuvanOsoite, $kuvanKokoX, $kuvanKokoY) {

		/* Lasketaan nykyinen pivs sekunnin tarkkuudella. Tm nytetn kuvaajassa. */
		$paivaysNyt = date('d.m.Y H:i:s');
	
		/* Mritelln kuinka monta pikseli tyhj tilaa on kuvaajan ylosassa ja kuvaajan vasemmalla puolella. */
		$valiaYlhaalla = 10;
		$valiaVasemmalla = 13;

		/* Mritelln kuinka pitkt ovat x- ja y-akselit. */
		$x_AkselinPituus = $kuvanKokoX-60;
		$y_AkselinPituus = $kuvanKokoY-80;

		/* Mritelln kuinka korkeita ovat x-akselin jakoviivat. */
		$jakoViivanPituus = 5;

		/* Mritelln kuvaajassa olevien tekstien fonttikoot. */
		$fonttiKokoInfo = 2;
		$fonttiKokoKavijamaarat = 2;
		$fonttiKokoPaivamaarat = 1;

		/* Luodaan kuva, johon aletaan piirt kuvaajaa. */
		$image = imagecreate ($kuvanKokoX, $kuvanKokoY);

		/* Mritelln kuvaajan taustan, viivojen ja tekstien vrit (RGB-muodossa). */
		$taustaVari = imagecolorallocate ($image, 224, 224, 224);
		$infoTekstinVari = imagecolorallocate ($image, 0, 110, 110);
		$jakoviivojenTekstinVari = imagecolorallocate ($image, 64, 64, 64);
		$katkoviivojenTekstinVari = imagecolorallocate ($image, 64, 64, 64);
		$graafinViivanVari = imagecolorallocate ($image, 0, 110, 110);
		$jakoviivanVari = imagecolorallocate ($image, 128, 128, 128);
		$katkoviivanVari = imagecolorallocate ($image, 128, 128, 128);


		/* Lasketaan aloituspivmrst ja lopetuspivmrst pivn, kuukauden ja vuoden numerot. 
		Nit tarvitaan, jotta voidaan laskea seuraava pivmr mktime-funktiolla. */

		$aloitusPaiva = date ("d", $aloitusPaivamaara);
		$aloitusKuukausi = date ("m", $aloitusPaivamaara);
		$aloitusVuosi = date ("Y", $aloitusPaivamaara);

		$lopetusPaiva = date ("d", $lopetusPaivamaara);
		$lopetusKuukausi = date ("m", $lopetusPaivamaara);
		$lopetusVuosi = date ("Y", $lopetusPaivamaara);

		/* Mritelln tarkasteltava pivmr ja pivmr, johon tarkastelu lopetataan muodossa vuosi-kuukausi-piv. */
		$tarkasteltavaPaivamaara = date ("Y-m-d", mktime (0,0,0,$aloitusKuukausi,$aloitusPaiva,$aloitusVuosi));
		$lopetusPaivamaara = date ("Y-m-d", mktime (0,0,0,$lopetusKuukausi,$lopetusPaiva,$lopetusVuosi));

		/* Luodaan taulukko, johon aletaan tallentamaan kvijmri pivi kohden. */
		$kavijaMaarat = array();

		/* Alustetaan mys muuttujat, joihin tallennetaan kvijmrien tarkastelun aikana 
		suurin ja pienin arvo. Muuttujat alustetaan global-tyyppisiksi, jotta niiden arvoja voi kytt mys funktion ulkopuolella.
		Suurin arvo alustetaan nollaan (tt pienemp kvijmr ei voi olla) 
		ja pienin arvo alustetaan biljoonaan (tt suurempaa kvijmr ei missn voi kytnnss olla). */

		global $suurinArvo, $pieninArvo, $suurinArvoPvm, $pieninArvoPvm;
		
		$suurinArvo = 0;
		$pieninArvo = 1000000000000;

		/* Lhdetn lukemaan kvijmri parametrina annetun kansion tiedostoista. 
		Pivkohtaiset kvijmrt tytyvt olla tallennettuna tiedostoihin, jotka ovat nimeltn muotoa 
		vuosi-kuukausi-piv.txt, eli esim. vuoden 2005 jouluaaton kvijmrt tytyvt olla tallennettuna 
		tiedostoon 2005-12-24.txt. Kansion tiedostojen sisltmi kvijmri luetaan aloituspivmrst 
		lopetuspivmrn asti. Tarkasteltava pivmr alustettiin siis edell aloituspivmrn ja 
		for-loopissa tarkasteltavaa pivmr kasvatetaan aina yhdell pivll eteenpin askel kerrallaan. */
		
		for ($i = 0; $tarkasteltavaPaivamaara<$lopetusPaivamaara; $i++) 
		{

			// Mritelln pivmr, jonka kvijmr ollaan tarkastelemassa. Pivmr kasvatetaan yhdell per looppi.
			$tarkasteltavaPaivamaara = date ("Y-m-d", mktime (0,0,0,$aloitusKuukausi,$aloitusPaiva+$i,$aloitusVuosi));
			
			// Mritelln pivmr vastaava tiedosto, johon on tallennettu tiedot kyseisen pivn kvijmrst.
			$kavijaMaaraTiedosto = $kavijaTiedotKansio.$tarkasteltavaPaivamaara.".txt";

			/* Luetaan edell mritellyn tiedoston sisltm kvijmr.  */
			$kavijaMaarat[$i] = lueKavijamaara($kavijaMaaraTiedosto);
			
			/* Jos luettu kvijmr on suurempi kuin aiempi suurin kvijmr, pivitetn suurin kvijmr 
			ja otetaan mys yls suurimman kvijmrn omaavan pivn UNIX-timestamp. Sama asia tehdn, 
			jos luettu kvijmr on pienempi kuin aiempi pienin kvijmr. */

			if ($kavijaMaarat[$i] > $suurinArvo) {
				$suurinArvo = $kavijaMaarat[$i];
				$suurinArvoPvm = mktime (0,0,0,$aloitusKuukausi,$aloitusPaiva+$i,$aloitusVuosi);
			} elseif ($kavijaMaarat[$i] < $pieninArvo) {
				$pieninArvo = $kavijaMaarat[$i];
				$pieninArvoPvm = mktime (0,0,0,$aloitusKuukausi,$aloitusPaiva+$i,$aloitusVuosi);
			}

		}  // For-loopin loppu

		/* Lasketaan monenko pivn kvijmrtiedot tallennettiin taulukkoon (eli taulukon koko) */
		$montakoPaivaa = count($kavijaMaarat);
		

		/* Mritelln pikselin koko y-akselin suunnassa. Tt tarvitaan, ett voidaan helposti
		piirt kvijmri kuvaajan kyr. */
		$pikseliY = $y_AkselinPituus/$suurinArvo;
		
		/* Mritelln pikselin koko x-akselin suunnassa. Tt tarvitaan, ett voidaan helposti 
		piirt kvijmri kuvaava kyr. */
		$pikseliX = $x_AkselinPituus/($montakoPaivaa-1);


		/* Mritelln suurimman ja pienimmn arvon pivmrn tulostusmuoto. */
		$suurinArvoPvm2 = date ("j.n.y", $suurinArvoPvm);
		$pieninArvoPvm2 = date ("j.n.y", $pieninArvoPvm);

		/* Piirretn info-tekstit. Tekstiss kerrotaan montako piv kuvaajassa nytetn ja minimi/maksimi kvijmrt. */
		imagestring ($image, $fonttiKokoInfo, 5, $kuvanKokoY-30, 
		"Yhteens $montakoPaivaa piv. Max. $suurinArvo kvij/piv ($suurinArvoPvm2), Min. $pieninArvo kvij/piv ($pieninArvoPvm2).", $infoTekstinVari);
		imagestring ($image, $fonttiKokoInfo, 5, $kuvanKokoY-15, "Kuvaaja luotu: $paivaysNyt", $infoTekstinVari);


		/* Mritelln y-akselin katkoviivojen jakovli, eli mik on se vli, kuinka usein piirretn kvijmr vastaava 
		katkoviiva ja kvijmrn luku. Jakovli lasketaan pyristmll luettujen kvijmrien suurin arvo siten, ett 
		luku pyristetn yhden merkitsevn numeron tarkkuudelle. Esim. 6782 pyristetn 7000:een ja 230 pyristetn 200:aan. 
		Tm saatu luku jaetaan viel 10:ll, jolloin saadaan se vli, kuinka useasti katkoviivat piirretn. 
		Esim. jos maksimikvijmr on 3456, piirretn katkoviivat 300 kvijn vlein. */

		$jakoVali = round($suurinArvo, 0-(strlen($suurinArvo))+1)/10;

		/* Mritelln viivan piirrostyyli katkoviivaksi. */	
		$b = $katkoviivanVari;
		$bg = $taustaVari;
		$style = array ($b,$b,$b,$b,$bg,$bg,$bg,$bg);
		imagesetstyle ($image, $style);

		/* Piirretn sken lasketuin vlein y-akselin katkoviivat ja vastaavat kvijmrt. */
		
		for ($i = 0; $i<=$suurinArvo; $i=$i+$jakoVali) 
		{
			imagestring($image, $fonttiKokoKavijamaarat, $x_AkselinPituus+$valiaVasemmalla+10, $y_AkselinPituus-$i*$pikseliY+$valiaYlhaalla-8, $i, $katkoviivojenTekstinVari);
			imageline ($image, 0+$valiaVasemmalla, $y_AkselinPituus-$i*$pikseliY+$valiaYlhaalla, $x_AkselinPituus+$valiaVasemmalla, $y_AkselinPituus-$i*$pikseliY+$valiaYlhaalla, IMG_COLOR_STYLED);
		}

		/* Piirretn kuvaajan vasemmalla ja oikealla reunalla olevat pystysuorat katkoviivat. */
		imageline ($image, $x_AkselinPituus+$valiaVasemmalla, $y_AkselinPituus+$valiaYlhaalla, $x_AkselinPituus+$valiaVasemmalla, 0, IMG_COLOR_STYLED);
		imageline ($image, $valiaVasemmalla, $y_AkselinPituus+$valiaYlhaalla, $valiaVasemmalla, 0, IMG_COLOR_STYLED);


		/* Lasketaan, montako x-akselin jakoviivaa piirretn. Viivoja piirretn sit useampia, 
		mit suurempi kuva on x-akselin suunnassa. Lasketaan jakomrn perusteella, kuinka monen pivn vlein 
		x-akselin jakoviiva piirretn. */
		
		$jakoMaara = round($kuvanKokoX*0.025); 
		$jakoValiPaiva = round(($montakoPaivaa-1)/$jakoMaara);

		/* Piirretn varsinainen kyr kuvaamaan kvijmrn kehityst. For-looppi piirt useita viivoja perkkin. */

		for ($i = 0; $i<=$montakoPaivaa-1; $i++) 
		{
			/* Viivan alkupisteen on x-akselilla, monesko piv on kyseess ja y-akselilla pivn kvijmr. 
			Loppupisteet ovat samat, mutta tarkastellaan vain seuraavaa piv. */
			
			$alkuPisteX = $pikseliX*$i+$valiaVasemmalla;
			$alkuPisteY = $y_AkselinPituus-$kavijaMaarat[$i]*$pikseliY+$valiaYlhaalla;
			$loppuPisteX = $pikseliX*($i+1)+$valiaVasemmalla;
			$loppuPisteY = $y_AkselinPituus-$kavijaMaarat[$i+1]*$pikseliY+$valiaYlhaalla;

			/* Piirretn viiva alkupisteest loppupisteeseen, jos ei olla viimeisess tarkasteltavassa pivss (tllin piirretn 
			vain x-akselin jakoviiva ja sit vastaava pivmr). */
			if ($i!=$montakoPaivaa-1) 
				imageline ($image, $alkuPisteX, $alkuPisteY, $loppuPisteX, $loppuPisteY, $graafinViivanVari);

			/* Piirretn x-akselille jakoviiva, jos tarkasteltava piv on jaollinen skettin lasketulla jakoValiPaiva:lla. 
			Eli siis viivoja tulee tllin piirretyksi vain jakoValiPaiva:n vlein. */
			
			if ($i % $jakoValiPaiva == 0) {
				// Piirretn x-akselin jakoviiva
				imageline ($image, $alkuPisteX, $y_AkselinPituus+$valiaYlhaalla, $alkuPisteX, $y_AkselinPituus+$jakoViivanPituus+$valiaYlhaalla, $jakoviivanVari);

				// Mritetn pivmr, joka nytetn jakoviivan alla ja piirretn se muodossa piv.kuukausi ja tmn alle vuosi
				$pvm = mktime (0,0,0,$aloitusKuukausi,$aloitusPaiva+$i,$aloitusVuosi);
				imagestring($image, $fonttiKokoPaivamaarat, $alkuPisteX-7, $y_AkselinPituus+$valiaYlhaalla+10, date ("j.n", $pvm), $jakoviivojenTekstinVari);
				imagestring($image, $fonttiKokoPaivamaarat, $alkuPisteX-7, $y_AkselinPituus+$valiaYlhaalla+20, date ("Y", $pvm), $jakoviivojenTekstinVari);
			}


		}  // For-loopin loppu

		
		/* Tallennetaan kuva png-muodossa parametrina annettuun osoitteeseen .*/
		imagepng ($image, $kuvanOsoite);


	}


	/* KUVAAJIEN PIIRTO */
	
	/* Kutsutaan kuvaajan piirto-funktiota aloituspivll , joka on pivmr kuukausi sitten. Kuvaajan piirto lopetetaan 
	eiliseen pivn (eli kuluvan pivn kvijmr ei piirret). */
	piirraKuvaaja(mktime(0, 0, 0, date("m"), date("d")-30, date("Y")), 
	mktime(0, 0, 0, date("m"), date("d"), date("Y")), $kavijatKansio."paivat/", 
	"../graafit/kuvaaja_31paivaa.png", 600, 300);

	/* Kutsutaan kuvaajan piirto-funktiota aloituspivll 01.01.2004. 
	TMN KUVAAJAN PIIRTO PIT OLLA VIIMEISEN, JOTTA MAX. KVIJMR VOIDAAN ESITT TIETOA-SIVULLA.*/
	piirraKuvaaja(mktime(0, 0, 0, 01, 01, 2004), 
	mktime(0, 0, 0, date("m"), date("d"), date("Y")), $kavijatKansio."paivat/", 
	"../graafit/kuvaaja_kokoAika.png", 600, 400);

	
	/* Luetaan kvijt, lataukset ja lasketaan lataukset per kvij. */
	$kavijatYhteensa = lueKavijamaara ($kavijatKansio."kavijat.txt");
	$latauksetYhteensa = lueKavijamaara ($kavijatKansio."lataukset.txt");
	$latauksiaPerKavija = $latauksetYhteensa/$kavijatYhteensa;

	/* Luetaan viikonpivkohtaiset kvijmrt. */
	$maanantai = lueKavijamaara ($kavijatKansio."viikonpaivat/Mon.txt");
	$tiistai = lueKavijamaara ($kavijatKansio."viikonpaivat/Tue.txt");
	$keskiviikko = lueKavijamaara ($kavijatKansio."viikonpaivat/Wed.txt");
	$torstai = lueKavijamaara ($kavijatKansio."viikonpaivat/Thu.txt");
	$perjantai = lueKavijamaara ($kavijatKansio."viikonpaivat/Fri.txt");
	$lauantai = lueKavijamaara ($kavijatKansio."viikonpaivat/Sat.txt");
	$sunnuntai = lueKavijamaara ($kavijatKansio."viikonpaivat/Sun.txt");

	$kaikkiViikonPaivat = $maanantai+$tiistai+$keskiviikko+$torstai+$perjantai+$lauantai+$sunnuntai;

	/* Lasketaan eri viikonpivien prosenttiosuudet kokonaiskvijmrst. */
	$maanantaiProsentit = round($maanantai/$kaikkiViikonPaivat*100, 1);
	$tiistaiProsentit = round($tiistai/$kaikkiViikonPaivat*100, 1);
	$keskiviikkoProsentit = round($keskiviikko/$kaikkiViikonPaivat*100, 1);
	$torstaiProsentit = round($torstai/$kaikkiViikonPaivat*100, 1);
	$perjantaiProsentit = round($perjantai/$kaikkiViikonPaivat*100, 1);
	$lauantaiProsentit = round($lauantai/$kaikkiViikonPaivat*100, 1);
	$sunnuntaiProsentit = round($sunnuntai/$kaikkiViikonPaivat*100, 1);


	/* Luetaan kvijmrt tunneittain. */
	$tunnit00 = lueKavijamaara ($kavijatKansio."tunnit/00.txt");
	$tunnit01 = lueKavijamaara ($kavijatKansio."tunnit/01.txt");
	$tunnit02 = lueKavijamaara ($kavijatKansio."tunnit/02.txt");
	$tunnit03 = lueKavijamaara ($kavijatKansio."tunnit/03.txt");
	$tunnit04 = lueKavijamaara ($kavijatKansio."tunnit/04.txt");
	$tunnit05 = lueKavijamaara ($kavijatKansio."tunnit/05.txt");
	$tunnit06 = lueKavijamaara ($kavijatKansio."tunnit/06.txt");
	$tunnit07 = lueKavijamaara ($kavijatKansio."tunnit/07.txt");
	$tunnit08 = lueKavijamaara ($kavijatKansio."tunnit/08.txt");
	$tunnit09 = lueKavijamaara ($kavijatKansio."tunnit/09.txt");
	$tunnit10 = lueKavijamaara ($kavijatKansio."tunnit/10.txt");
	$tunnit11 = lueKavijamaara ($kavijatKansio."tunnit/11.txt");
	$tunnit12 = lueKavijamaara ($kavijatKansio."tunnit/12.txt");
	$tunnit13 = lueKavijamaara ($kavijatKansio."tunnit/13.txt");
	$tunnit14 = lueKavijamaara ($kavijatKansio."tunnit/14.txt");
	$tunnit15 = lueKavijamaara ($kavijatKansio."tunnit/15.txt");
	$tunnit16 = lueKavijamaara ($kavijatKansio."tunnit/16.txt");
	$tunnit17 = lueKavijamaara ($kavijatKansio."tunnit/17.txt");
	$tunnit18 = lueKavijamaara ($kavijatKansio."tunnit/18.txt");
	$tunnit19 = lueKavijamaara ($kavijatKansio."tunnit/19.txt");
	$tunnit20 = lueKavijamaara ($kavijatKansio."tunnit/20.txt");
	$tunnit21 = lueKavijamaara ($kavijatKansio."tunnit/21.txt");
	$tunnit22 = lueKavijamaara ($kavijatKansio."tunnit/22.txt");
	$tunnit23 = lueKavijamaara ($kavijatKansio."tunnit/23.txt");

	$tunnitKaikki = $tunnit00+$tunnit01+$tunnit02+$tunnit03+$tunnit04+$tunnit05
	+$tunnit06+$tunnit07+$tunnit08+$tunnit09+$tunnit10+$tunnit11+$tunnit12+$tunnit13
	+$tunnit14+$tunnit15+$tunnit16+$tunnit17+$tunnit18+$tunnit19+$tunnit20+$tunnit21
	+$tunnit22+$tunnit23;

	/* Lasketaan prosenttiosuudet kolmen tunnin vlein kokonaiskvijmrst. */
	$tunnit_00_03_Prosentit = round(($tunnit00+$tunnit01+$tunnit02)/$tunnitKaikki*100, 1);
	$tunnit_03_06_Prosentit = round(($tunnit03+$tunnit04+$tunnit05)/$tunnitKaikki*100, 1);
	$tunnit_06_09_Prosentit = round(($tunnit06+$tunnit07+$tunnit08)/$tunnitKaikki*100, 1);
	$tunnit_09_12_Prosentit = round(($tunnit09+$tunnit10+$tunnit11)/$tunnitKaikki*100, 1);
	$tunnit_12_15_Prosentit = round(($tunnit12+$tunnit13+$tunnit14)/$tunnitKaikki*100, 1);
	$tunnit_15_18_Prosentit = round(($tunnit15+$tunnit16+$tunnit17)/$tunnitKaikki*100, 1);
	$tunnit_18_21_Prosentit = round(($tunnit18+$tunnit19+$tunnit20)/$tunnitKaikki*100, 1);
	$tunnit_21_00_Prosentit = round(($tunnit21+$tunnit22+$tunnit23)/$tunnitKaikki*100, 1);


	/* Mritelln tm piv, kuukausi ja vuosi. */
	setlocale(LC_TIME, "fi_FI");
	$paivaNyt = date("d");
	$kuukausiNyt =  date("m");
	$vuosiNyt =  date("Y");

	/* Luetaan kvijmrt tnn ja eilen. */
	$kavijatTanaan = lueKavijamaara ($kavijatKansio."paivat/".
	date("Y-m-d", mktime (0,0,0,$kuukausiNyt,$paivaNyt,$vuosiNyt)).".txt");
	$kavijatEilen = lueKavijamaara ($kavijatKansio."paivat/".
	date("Y-m-d", mktime (0,0,0,$kuukausiNyt,$paivaNyt-1,$vuosiNyt)).".txt");

	/* Luetaan kvijmrt tll viikolla ja viime viikolla. */
	$kavijatTallaViikolla = lueKavijamaara ($kavijatKansio."viikot/".strftime("%G-vko-%V").".txt");
	$kavijatViimeViikolla = lueKavijamaara ($kavijatKansio."viikot/".strftime("%G-vko-%V", 
	mktime (0,0,0,$kuukausiNyt,$paivaNyt-7,$vuosiNyt)).".txt");

	/* Luetaan kvijmrt tss kuussa ja viime kuussa. */
	$kavijatTassaKuussa = lueKavijamaara ($kavijatKansio."kuukaudet/".
	date("Y#m", mktime (0,0,0,$kuukausiNyt,$paivaNyt,$vuosiNyt)).".txt");
	$kavijatViimeKuussa = lueKavijamaara ($kavijatKansio."kuukaudet/".
	date("Y#m", mktime (0,0,0,$kuukausiNyt-1,1,$vuosiNyt)).".txt");


	/* Lasketaan kuukausittaisista kvijmrist tmn vuoden ja viime vuoden kvijmrt. 
	Eli looppi ky lpi tmn ja viime vuoden kuukausittaiset kvijmrtiedostot jokaiselta vuoden kuukaudelta.*/

	$kavijatTanaVuonna = 0;
	$kavijatViimeVuonna = 0;

	for ($i=1; $i<=12; $i++) {

		$tarkasteltavaKuukausi1 = date ("Y#m", mktime (0,0,0,$i,1,$vuosiNyt));
		$tarkasteltavaTiedosto1 = $kavijatKansio."kuukaudet/".$tarkasteltavaKuukausi1.".txt";

		$tarkasteltavaKuukausi2 = date ("Y#m", mktime (0,0,0,$i,1,$vuosiNyt-1));
		$tarkasteltavaTiedosto2 = $kavijatKansio."kuukaudet/".$tarkasteltavaKuukausi2.".txt";

		$kavijatTanaVuonna = $kavijatTanaVuonna + lueKavijamaara ($tarkasteltavaTiedosto1);
		$kavijatViimeVuonna = $kavijatViimeVuonna + lueKavijamaara ($tarkasteltavaTiedosto2);

	}


	/* Lasketaan kuinka monen kuukauden kvijmrt on tallennettu tiedostoihin tn vuonna ja viime vuonna. */
	$kuukausiaTanaVuonna = laskeTiedostot ($kavijatKansio."kuukaudet/", $vuosiNyt."#");
	$kuukausiaViimeVuonna = laskeTiedostot ($kavijatKansio."kuukaudet/", ($vuosiNyt-1)."#");

	/* Lasketaan kuinka monen viikon kvijmrt on tallennettu tiedostoihin tn vuonna ja viime vuonna. */
	$viikkojaTanaVuonna = laskeTiedostot ($kavijatKansio."viikot/", $vuosiNyt."-vko-");
	$viikkojaViimeVuonna = laskeTiedostot ($kavijatKansio."viikot/", ($vuosiNyt-1)."-vko-");

	/* Lasketaan kuinka monen pivn kvijmrt on tallennettu tiedostoihin tn vuonna ja viime vuonna. */
	$paiviaTanaVuonna = laskeTiedostot ($kavijatKansio."paivat/", $vuosiNyt."-");
	$paiviaViimeVuonna = laskeTiedostot ($kavijatKansio."paivat/", ($vuosiNyt-1)."-");


	/* Lasketaan edellisten arvojen perusteella tmn ja viime vuoden kvijt per kuukausi, viikko ja piv. */

	$kavijatPerKuukausiTanaVuonna = $kavijatTanaVuonna/$kuukausiaTanaVuonna;
	if ($kuukausiaViimeVuonna > 0)
		$kavijatPerKuukausiViimeVuonna = $kavijatViimeVuonna/$kuukausiaViimeVuonna;
	else 
		$kavijatPerKuukausiViimeVuonna = 0;

	if ($viikkojaTanaVuonna > 0)
		$kavijatPerViikkoTanaVuonna = $kavijatTanaVuonna/$viikkojaTanaVuonna;
	else 
		$kavijatPerViikkoTanaVuonna = 0;
	if ($viikkojaViimeVuonna > 0)
		$kavijatPerViikkoViimeVuonna = $kavijatViimeVuonna/$viikkojaViimeVuonna;
	else
		$kavijatPerViikkoViimeVuonna = 0;

	$kavijatPerPaivaTanaVuonna = $kavijatTanaVuonna/$paiviaTanaVuonna;
	if ($paiviaViimeVuonna > 0)
		$kavijatPerPaivaViimeVuonna = $kavijatViimeVuonna/$paiviaViimeVuonna;
	else
		$kavijatPerPaivaViimeVuonna = 0;


?>

<html>
<head>
<title>Tilastotiedot kvijist</title>
<meta name="robots" content="noarchive, noindex, nofollow">
<meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1"/>
<link rel="stylesheet" type="text/css" href="tyylit.css" />
</head>

<body>

	<h2>Alla hieman tilastotietoa sivuston kvijmrist</h2>

	<table style="width: 300px; float: left; margin: 0 10px 20px 0;">
		<caption>Taulukko 1. Yleist tilastotietoa kvijist</caption>
		<colgroup>
			<col width="70%"></col>
			<col width="30%" align="center"></col>
		</colgroup>
		<tbody>
			<tr>
				<th>Kvijit yhteens:</th>
				<td><?php print number_format($kavijatYhteensa, 0, ',', ' '); ?></td>
			</tr>
			<tr>
				<th>Latauksia yhteens:</th>
				<td><?php print number_format($latauksetYhteensa, 0, ',', ' '); ?></td>
			</tr>
			<tr>
				<th>Latauksia/kvij:</th>
				<td><?php print number_format($latauksiaPerKavija, 1, ',', ' '); ?></td>
			</tr>
			<tr>
				<th>Kvijit tnn:</th>
				<td><?php print number_format($kavijatTanaan, 0, ',', ' '); ?></td>
			</tr>
			<tr>
				<th>Kvijit eilen:</th>
				<td><?php print number_format($kavijatEilen, 0, ',', ' '); ?></td>
			</tr>
			<tr>
				<th>Kvijit tll viikolla:</th>
				<td><?php print number_format($kavijatTallaViikolla, 0, ',', ' '); ?></td>
			</tr>
			<tr>
				<th>Kvijit viime viikolla:</th>
				<td><?php print number_format($kavijatViimeViikolla, 0, ',', ' '); ?></td>
			</tr>
			<tr>
				<th>Kvijit tss kuussa:</th>
				<td><?php print number_format($kavijatTassaKuussa, 0, ',', ' '); ?></td>
			</tr>
			<tr>
				<th>Kvijit viime kuussa:</th>
				<td><?php print number_format($kavijatViimeKuussa, 0, ',', ' '); ?></td>
			</tr>
		</tbody>
	</table>


	<table style="width: 300px; float: left; margin: 0 10px 20px 0;">
		<caption>Taulukko 2. Tilastotietoa kvijist vuotta kohden</caption>
		<colgroup>
			<col width="50%"></col>
			<col width="25%" align="center"></col>
			<col width="25%" align="center"></col>
		</colgroup>
		<thead>
			<tr>
				<td>&nbsp;</td>
				<td><?php print ($vuosiNyt); ?></td>
				<td><?php print ($vuosiNyt-1); ?></td>
			</tr>
		</thead>
		<tbody>			
			<tr>
				<th>Kvijit/vuosi:</th>
				<td><?php print number_format($kavijatTanaVuonna, 0, ',', ' '); ?></td>
				<td><?php print number_format($kavijatViimeVuonna, 0, ',', ' '); ?></td>
			</tr>
			<tr>
				<th>Kvijit/kuukausi:</th>
				<td><?php print number_format($kavijatPerKuukausiTanaVuonna, 1, ',', ' '); ?></td>
				<td><?php print number_format($kavijatPerKuukausiViimeVuonna, 1, ',', ' '); ?></td>
			</tr>
			<tr>
				<th>Kvijit/viikko:</th>
				<td><?php print number_format($kavijatPerViikkoTanaVuonna, 1, ',', ' '); ?></td>
				<td><?php print number_format($kavijatPerViikkoViimeVuonna, 1, ',', ' '); ?></td>
			</tr>
			<tr>
				<th>Kvijit/piv:</th>
				<td><?php print number_format($kavijatPerPaivaTanaVuonna, 1, ',', ' '); ?></td>
				<td><?php print number_format($kavijatPerPaivaViimeVuonna, 1, ',', ' '); ?></td>
			</tr>
		</tbody>
	</table>

	<table style="width: 300px; clear: left; float: left; margin: 0 10px 20px 0;">
		<caption>Taulukko 3. Kvijt viikonpivi kohden</caption>
		<colgroup>
			<col align="center"></col>
			<col align="center"></col>
		</colgroup>
		<thead>
			<tr> 
				<td>Viikonpiv</td>
				<td>Kvijit</td>
			</tr>
		</thead>
		<tbody>
			<tr> 
				<td>Maanantai</td>
				<td><?php print number_format($maanantaiProsentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>Tiistai</td>
				<td><?php print number_format($tiistaiProsentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>Keskiviikko</td>
				<td><?php print number_format($keskiviikkoProsentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>Torstai</td>
				<td><?php print number_format($torstaiProsentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>Perjantai</td>
				<td><?php print number_format($perjantaiProsentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>Lauantai</td>
				<td><?php print number_format($lauantaiProsentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>Sunnuntai</td>
				<td><?php print number_format($sunnuntaiProsentit, 1, ',', ' '); ?> %</td>
			</tr>
		</tbody>
	</table>

	<table style="width: 300px; float: left; margin: 0 10px 20px 0;">
		<caption>Taulukko 4. Kvijt kellonaikoja kohden</caption>
		<colgroup>
			<col align="center"></col>
			<col align="center"></col>
		</colgroup>
		<thead>
			<tr>             
				<td>Kellonaika</td>
				<td>Kvijit</td>
			</tr>
		</thead>
		<tbody>
			<tr> 
				<td>00:00-03:00</td>
				<td><?php print number_format($tunnit_00_03_Prosentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>03:00-06:00</td>
				<td><?php print number_format($tunnit_03_06_Prosentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>06:00-09:00</td>
				<td><?php print number_format($tunnit_06_09_Prosentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>09:00-12:00</td>
				<td><?php print number_format($tunnit_09_12_Prosentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>12:00-15:00</td>
				<td><?php print number_format($tunnit_12_15_Prosentit, 1, ',', ' '); ?> % </td>
			</tr>
			<tr> 
				<td>15:00-18:00</td>
				<td><?php print number_format($tunnit_15_18_Prosentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>18:00-21:00</td>
				<td><?php print number_format($tunnit_18_21_Prosentit, 1, ',', ' '); ?> %</td>
			</tr>
			<tr> 
				<td>21:00-00:00</td>
				<td><?php print number_format($tunnit_21_00_Prosentit, 1, ',', ' '); ?> %</td>
			</tr>
		</tbody>
	</table>

	<p style="clear:left">Taulukossa 3 on taulukoitu tiedot siit, miten kvijmr 
	on jakautunut eri viikonpiville. Taulukosta 4 taas voi katsoa, mihin 
	aikaan ihmiset yleisimmin sivuilla kyvt.</p>
	
	
	<h2>Kvijmrn kehitys viimeisten 31 pivn osalta</h2>
	<p><img src="../graafit/kuvaaja_31paivaa.png" alt="Kvijmrn kehitys viimeisten 31 pivn osalta" style="border: thin black solid;" /></p>

	<h2>Kvijmrn kehitys koko ajalta</h2>
	<p><img src="../graafit/kuvaaja_kokoAika.png" alt="Kvijmrn kehitys koko ajalta" style="border: thin black solid;" /></p>

</body>
</html>