<?php

	#################################################
	# 									                                                #
	# 				MVnetin kvijlaskuri  						     #
	# 				http://www.mvnet.fi	 					     #
	# 				Versio: 2006-08-30		                                                #
	# 									                                                #
	#################################################


	/* Mritelln aika minuutteina, jonka jlkeen "estetyt IP-osoitteet" -tiedosto nollataan. 
	Vakiona arvo on yksi tunti eli 60 minuuttia. Jos siis saman IP-osoitteen omaava kvij tulee uudestaan 
	siville, ei hnt noteerata uudeksi kvijksi, koska hnen IP-osoitteensa on "estetyt IP-osoitteet" -tiedostossas. 
	Jos hn tulee uudestaan tunti sen jlkeen kun "estetyt IP-osoitteet" -tiedosto on viimeksi nollattu, 
	noteerataan hnet uudeksi kvijksi ja samalla "estetyt IP-osoitteet"-tiedosto nollataan.*/

	$vaihtoMinuutteina = 60;

	
	/* Mritelln se tiedostokoko kilotavuina, jolloin halutaan kavijatiedot.php-tiedoston nollaantuvan. 
	Jossain vaiheessa tmn tiedoston koko kasvaa niin suureksi, ett se ylitt alla olevan rajan (oletus 500), 
	jolloin tiedosto automaattisesti tyhjennetn. */

	$kavijatiedotNollaus = 500;

	/* Mritelln luettelo taulukkona, johon luetteloidaan ne host-osoitteiden osat, joita ei lasketa uusiksi kvijiksi. 
	Jos kvijn host-osoitteessa on taulukossa mainittu tekstinptk, ei sit lasketa uudeksi kvijksi. 
	Tm taulukko on tarkoitettu siihen, ett netin hakukoneet kuten Google eivt kasvattaisi virheellisesti kvijmri. 
	Voit est hakukoneen kasvattamasta kvijmr lismll osan sen host-osoitteesta thn listaan. Host-osoitteen osan pit olla 
	sellainen, ett hakubotti tunnistetaan siit aina. Esim. Googlen hakubotin host-osoite voi olla esim. crawl-66-249-65-205.googlebot.com, 
	mutta tt koko host-osoitetta ei laiteta listaan, koska tm yksili vain yhden Googlen hakubotin (ja nit Googlella on useita).
	Hakubotin host-osoitteen nkee esim. kvijtiedot-luettelosta etsimll sanoja: bot, search, crawl. */

	$eiLasketa = array("googlebot.com", "msnbot.msn.com", "inktomisearch.com");


	/* Funktio, joka tarkistaa, onko parametrina annettu host-osoite hakurobotin osoite, jotka on mritelty
	yll esitetyss taulukossa, joka annetaan funktion toisena parametrina. */
	
	function onHakurobotti($verrattavaHost, $array) {
		
		$onBotti = false;
		
		for ($i=0; $i<count($array); $i++) {
			if (eregi($array[$i], $verrattavaHost)) {
				$onBotti = true;
				break;
			}
		}
		
		return $onBotti;
	
	}
	
	
	/* Funktio, joka lukee parametrina annetun tiedoston sislln ja palauttaa sen. */

	function lueSisalto ($tiedosto)
	{
		return file_get_contents($tiedosto);
	}

	
	/* Funktio, joka lis parametrina annettun tiedoston loppuun parametrina annetun listtvn sislln. */

	function lisaaTiedostonLoppuun ($tiedosto, $lisattava)
	{	
		ignore_user_abort(true);

		$fd = fopen ($tiedosto, "a"); 

		/* Tiedostoon voi kirjoittaa vain, jos sen saa lukittua. Nin vltytn (toivottavasti) virheist, 
		joita tulisi, jos useampi kuin yksi yrittisi kirjoittaa tiedostoon samaan aikaan. */
		
		if (flock($fd, LOCK_EX)) {
			fwrite($fd, $lisattava);
			flock($fd, LOCK_UN); 
		}
		
		fclose($fd);

		ignore_user_abort(false);
	}	

	
	/* Funktio, joka ylikirjoittaa parametrina annetun tiedoston parametrina annetulla kirjoitettavalla sisllll. */

	function ylikirjoitaSisalto ($tiedosto, $kirjoitettava)
	{
		ignore_user_abort(true);
		
		$fd = fopen ($tiedosto, "w"); 
		fwrite($fd, $kirjoitettava);
		fclose($fd);
		
		ignore_user_abort(false);
	}


	/* Funktio, joka kasvattaa parametrina annetun tiedoston sislt yhdell. Eli funktio ensin lukee tiedoston sislln
	ja sitten lis sisltn 1:n ja ylikirjoittaa tiedoston sislln tll uudella arvolla. Jos parametrina annettua tiedostoa 
	ei ole olemassa, luodaan se ja chmodataan muotoon 766.*/

	function kasvataYhdella ($tiedosto)
	{

		ignore_user_abort(true);

		if (file_exists($tiedosto))
		{

			$fd = fopen ($tiedosto, "r+"); 

			/* Tiedostoon voi kirjoittaa vain, jos sen saa lukittua. Nin vltytn (toivottavasti) virheist, 
			joita tulisi, jos useampi kuin yksi yrittisi kirjoittaa tiedostoon samaan aikaan. */

			if (flock($fd, LOCK_EX)) {
				$aiempiArvo = fread ($fd, filesize ($tiedosto));  // Luetaan aiempi arvo
				$aiempiArvo++;   // Kasvatetaan aiempaa arvoa yhdell
				fseek($fd, 0);   // Laitetaan pointteri tiedoston alkuun ftruncatea varten
				ftruncate($fd, 0);   // Tyhjennetn tiedosto
				fwrite($fd, $aiempiArvo);   // Kirjoitetaan uusi arvo (eli aiempiArvo + 1)
				flock($fd, LOCK_UN); 
			}
			
			fclose($fd);

		} else {

			$fd = fopen ($tiedosto, "w"); 
			chmod ($tiedosto, 0766);  // Chmodataan tiedosto muotoon 766, jotta siihen voisi kirjoittaa
			fwrite($fd, "1");
			fclose($fd);

		}

		ignore_user_abort(false);

	}

	
	/* Tallennetaan muuttujiin nykyinen pivmr ja kellonaika, kvijn IP-osoite, IP-osoitetta vastaava host,
	kvijn selain/kyttjrjestelm sek osoite, jota kautta kvij tuli sivuille (referer) ja haettu URL (eli mille sivulle kvij tuli). */

	$aikaLeima = date('d.m.Y H:i:s'); 
	$ipOsoite = $_SERVER['REMOTE_ADDR']; 
	$host = gethostbyaddr($_SERVER['REMOTE_ADDR']);
	$selain = $_SERVER['HTTP_USER_AGENT']; 
	$referer = $_SERVER['HTTP_REFERER'];
	$requestURL = $_SERVER['REQUEST_URI'];


	/* Kasvatetaan latauslaskuria yhdell aina kun sivu ladataan  */
	$latausMaaratFile = $kavijatURL."lataukset.txt";   // Thn tallennetaan lataukset yhteens
	kasvataYhdella ($latausMaaratFile);

	
	/* Katsotaan, onko referer-osoite, josta kvij tuli sivulle saman sivuston sivuja. 
	Jos referer-sivu on tmn sivuston sivuja, ei kvij tietenkn voi olla uusi kvij, 
	koska hn on klikannut linkki tlt sivustolta. Kvij ei siis noteerata uudeksi 
	kvijksi, jos referer-osoite kuuluu samaan sivustoon.
	kotisivunOsoite-muuttuja mritelln "Jokaisen sivun alkuun"-koodissa. 
	Jos kyseess on hakurobotti, joka tunnistetaan sivun alussa mritellyst host-luettelosta, 
	ei hakurobotin kynti noteerata.*/
	
	if (!eregi($kotisivunOsoite, $referer) && !onHakurobotti($host, $eiLasketa)) {

	
		/* Mritelln tiedostoja, joihin tallennetaan tietoja kvijist. Tiedostojen osoitteet ovat suhteellisia osoitteita. 
		Osoitteiden edess oleva kavijatURL-muuttuja saadaan "Jokaisen sivun alkuun" -koodista. */

		$ipEstotOsoitteetFile = $kavijatURL."ipEsto/ipesteet.txt";   // Estetyt IP-osoitteet-tiedosto
		$ipEstotAikaFile = $kavijatURL."ipEsto/tunnit.txt";   // Estetyt IP-osoitteet-tiedoston viimeisen nollauksen kellonaika minuutteina
		$ipEstotPaivaFile = $kavijatURL."ipEsto/paivat.txt";    // Estetyt IP-osoitteet-tiedoston viimeisen nollauksen pivn numero
		$kavijaMaaratFile = $kavijatURL."kavijat.txt";   // Thn tallennetaan kvijmr yhteens
		$kavijatiedotFile = $kavijatURL."kavijatiedot.php";   // Thn tallennetaan tietoja kvijist (kellonaika, IP-osoite, referer ...)
		
		/* Mritelln tiedostot, joihin tallennetaan piv, viikko ja kuukausi -kohtaiset kvijmrt. */
		setlocale(LC_TIME, "fi_FI");
		$paivaFile = $kavijatURL."paivat/".strftime("%Y-%m-%d").".txt";   // Pivkohtaiset kvijmrt
		$viikkoFile = $kavijatURL."viikot/".strftime("%G-vko-%V").".txt";   // Viikkokohtaiset kvijmrt (vko 1-53)
		$kuukausiFile = $kavijatURL."kuukaudet/".strftime("%Y#%m").".txt";     // Kuukausikohtaiest kvijmrt

		/* Mritelln tiedostot, joihin tallennetaan kvijmrt tunneittain ja viikonpivittin. */
		$tuntiFile = $kavijatURL."tunnit/".strftime("%H").".txt";  // Kvijmrt tuntia kohden (00-23)
		$viikonpaivaFile = $kavijatURL."viikonpaivat/".date('D').".txt";  // Kvijmrt viikonpivi kohden (Mon - Sun)

		
		/* Tallennetaan muuttujiin tmn pivn pivyksen pivn numero ja kellonajan tunnit sek minuutit. */
		$tamaPaiva = getdate(); 
		$paivaNyt = $tamaPaiva['yday'];  // Vuoden pivn numero nyt (1-366)
		$tunnitNyt = $tamaPaiva['hours'];  // Kellonajan tunnit nyt
		$minuutitNyt = $tamaPaiva['minutes'];  // Kellonajan minuutit nyt

		/* Luetaan ne estetyt IP-osoitteet, joiden kynti ei lasketa uudeksi kvijksi. */
		$estetytIpOsoitteet = lueSisalto ($ipEstotOsoitteetFile);

		/* Luetaan se kellonaika minuutteina ja pivn numero, jolloin estetyt IP-osoitteet -tiedosto viimeksi nollattiin.  */
		$estoAikaMinuutteina = lueSisalto ($ipEstotAikaFile);
		$estoPaiva = lueSisalto ($ipEstotPaivaFile);

		
		/* Lasketaan erotus minuuteina: (nykyinen kellonaika) - (estetyt IP-osoitteet -tiedoston nollauksen kellonaika)  */
		$aikaErotus = 60*$tunnitNyt+$minuutitNyt-$estoAikaMinuutteina;

		/* Jos sken laskettu erotus on suurempi tai yhtsuuri kuin alussa mritelty vaihtoMinuutteina-muuttuja (oletus 60 minuuttia) tai 
		jos nykyinen pivn numero on eri kuin estetyt IP-osoitteet -tiedoston nollauksen pivn numero, nollataan estetyt IP-osoitteet -tiedosto. */

		if ($aikaErotus >= $vaihtoMinuutteina || $estoPaiva != $paivaNyt)
		{

			/* Kirjoitetaan uudet estetyt IP-osoitteet -tiedoston nollausajat  */
			ylikirjoitaSisalto ($ipEstotAikaFile, 60*$tunnitNyt+$minuutitNyt);
			ylikirjoitaSisalto ($ipEstotPaivaFile, $paivaNyt);

			/* Nollataan estetyt IP-osoitteet -tiedosto. */
			ylikirjoitaSisalto ($ipEstotOsoitteetFile, "");
			$estetytIpOsoitteet = "";

		}

		
		/* Katsotaan, onko kvijn IP-osoite jo estettyjen IP-osoitteiden listassa. Jos ei ole, tulkitaan kvij uudeksi kvijksi 
		ja listn yksi kvij lis laskureihin. Jos IP-osoite on jo estettyjen IP-osoitteiden listassa, ei kirjoiteta kvijlaskuriin uutta kvij. */

		if (!ereg($ipOsoite, $estetytIpOsoitteet))
		{ 

			/* Listn kvijn IP-osoite estetyt IP-osoitteet -tiedostoon. */
			lisaaTiedostonLoppuun ($ipEstotOsoitteetFile, $ipOsoite);

			/* Kasvatetaan kvijmrien laskureita. */
			kasvataYhdella ($kavijaMaaratFile);  // Kaikki kvijt yhteens
			kasvataYhdella ($paivaFile);  // Pivmrkohtaiset kvijmrt
			kasvataYhdella ($viikkoFile);  // Viikkokohtaiset kvijmrt
			kasvataYhdella ($kuukausiFile);  // Kuukausikohtaiset kvijmrt
			kasvataYhdella ($tuntiFile);  // Kivjmrt tunneittain
			kasvataYhdella ($viikonpaivaFile);  // Kvijmrt viikonpivittin


			/* Kirjoitetaan tiedot kvijst (kellonaika, IP-osoite, referer, selain/kyttjrjestelm ...).  */

			$kavijatiedotKoko = filesize ($kavijatiedotFile) / 1024;  // Kvijtiedot-tiedoston koko kilotavuina

			if ($referer == "")
				$referer = "suora";   // Jos kvij on tullut suoraan sivuille, on referer-osoite "suora".

			/* Kvijn tiedot kirjoietaan tiedostoon html-taulukon soluina.  */
			$kirjoitaTiedot = "
			<tr>
			<td>$aikaLeima</td>
			<td>$ipOsoite -- $host</td>
			<td>$referer</td>
			<td>$requestURL</td>
			<td>$selain</td>
			</tr>
			";

			/* Jos kvijtiedot-sivu on kasvanut liian suureksi, nollataan se ja listn tiedoston 
			alkuun peruskoodi, joka sislt salasanakyselyn */

			$peruskoodi = "
			<?php
			include(\"peruskoodi.php\");
			?>";


			/* Katsotaan, onko kavijatiedot.php -sivun tiedostokoko saavuttanut sen nollausrajan. 
			Jos tiedostokoko on suurempi tai yhtsuuri kuin alussa mritelty nollausraja, tyhjennetn sivu ennen 
			uuden kvijn tietojen lisyst. Muutoin listn vain tiedot sivun loppuun muiden tietojen pern.*/

			if ($kavijatiedotKoko >= $kavijatiedotNollaus)
				ylikirjoitaSisalto ($kavijatiedotFile, $peruskoodi.$kirjoitaTiedot);
			else
				lisaaTiedostonLoppuun ($kavijatiedotFile, $kirjoitaTiedot);


		}  // Uuden kvijn tietojen ja laskurien kasvattamisen if-lauseen loppu


		clearstatcache ();
	
	}

?>